=== debian/changelog ===
ros-kinetic-swarmros (0.3.6-2xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Ákos Milánkovich <akos.milankovich@search-lab.hu>  Tue, 14 Apr 2020 12:03:41 -0000
