=== debian/control ===
Source: ros-kinetic-swarmros
Section: misc
Priority: extra
Maintainer: Ákos Milánkovich <akos.milankovich@search-lab.hu>
Build-Depends: debhelper (>= 9.0.0), clang, cmake, g++-5-arm-linux-gnueabihf, g++-5-multilib, git, multistrap, ros-kinetic-rosconsole, ros-kinetic-roscpp, ros-kinetic-roslib, ros-kinetic-std-msgs
Homepage: http://www.cpswarm.eu
Standards-Version: 3.9.2

Package: ros-kinetic-swarmros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-kinetic-rosconsole, ros-kinetic-roscpp, ros-kinetic-roslib, ros-kinetic-std-msgs
Description: SwarmIO communications bridge for ROS
